from flask import Blueprint, request
from controllers.glb_controller import GlbController

glb_bp = Blueprint('glb', __name__)
controller = GlbController()

def setup_routes(app):
    @app.route('/glb', methods=['GET'])
    def get_glb():
        base_image_url = request.args.get('base_image_url', type=str)
        hf_token = request.args.get('hf_token', '', type=str)
        ss_guidance_strength = request.args.get('ss_guidance_strength', 7.5, type=float)
        ss_sampling_steps = request.args.get('ss_sampling_steps', 12, type=int)
        slat_guidance_strength = request.args.get('slat_guidance_strength', 3, type=float)
        slat_sampling_steps = request.args.get('slat_sampling_steps', 12, type=int)
        multiimage_algo = request.args.get('multiimage_algo', 'stochastic', type=str)
        mesh_simplify = request.args.get('mesh_simplify', 0.95, type=bool)
        texture_size = request.args.get('texture_size', 1024, type=int)

        return controller.get_glb(hf_token, base_image_url, ss_guidance_strength,
                                  ss_sampling_steps, slat_guidance_strength,
                                  slat_sampling_steps, multiimage_algo,
                                  mesh_simplify, texture_size)
